Bug 150130 - e1000 has memory leak when run continuously getting new dhcp leases.
e1000 has memory leak when run continuously getting new dhcp leases.
Product: Red Hat Enterprise Linux 3
Classification: Red Hat
Component: kernel (Show other bugs)
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: John W. Linville
Brian Brock
Depends On:
Blocks: 156320
  Show dependency treegraph
Reported: 2005-03-02 15:05 EST by David Knierim
Modified: 2007-11-30 17:07 EST (History)
3 users (show)

See Also:
Fixed In Version: RHSA-2005-663
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2005-09-28 10:50:20 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Script to reproduce failure. (609 bytes, text/plain)
2005-03-14 08:46 EST, David Knierim
no flags Details

  None (edit)
Description David Knierim 2005-03-02 15:05:11 EST
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.7.5)
Gecko/20041111 Firefox/1.0

Description of problem:
As part of a diagnostic suite, we have a script that shuts down all
interfaces and then brings them all back up configured to get IP
information from a DHCP server.   Once a good IP address is found, the
script then brings the interfaces down and the process is repeated.

Initially, this code runs without any error, but after running this
code for a while, errors like this are displayed when the test
attempts to bring up the interface:
"e1000: ethX: e1000_setup_tx_resources: Unble to Allocate Memory for
the Transmit descriptor ring" or a similar message for the Receive
descriptor ring.

We had no problem with Red Hat 9 with the same hardware and test

I upgraded the e1000 driver to the latest version from Intel (5.7.6)
and the problem did not occur.

The problem seems to happen  more frequently if the box in question
has more interfaces under test.

Version-Release number of selected component (if applicable):
kernel 2.4.21-27.0.2.ELsmp, e1000 version 5.3.19-k2-NAPI

How reproducible:

Steps to Reproduce:
1.configure a network with dhcp server
2.attach test client to network
3.configure test client to get IP addresses from DHCP
4.repeatedly have client bring up and down it's interface
5.eventually, it will fail

Actual Results:  Eventually, you will get an error: "e1000: ethX:
e1000_setup_tx_resources: Unble to Allocate Memory for the Transmit
descriptor ring" and you will no longer be able to bring up any
interfaces that are not already up.   Even something as simple as
"ifconfig eth0 up" will fail.

Expected Results:  Should be able to bring up and down interfaces for
an infinite number of times.

Additional info:
Comment 1 John W. Linville 2005-03-03 14:18:38 EST

Can you try kernel 2.4.21-28.ELsmp?  It includes an update of the
e1000 driver to

If you can't get hold of that version, the update is available in the
test kernels here:


Please attempt to recreate the issue and report the results.  Thanks!
Comment 2 David Knierim 2005-03-08 08:36:58 EST
I ran the test profile against kernel
kernel-smp-2.4.21-28.EL.jwltest.3.i686.rpm.  It failed in the same
manner as 2.4.21-27.0.2.ELsmp.  
Comment 3 John W. Linville 2005-03-08 16:53:05 EST
David, can I persuade you to attach the test script you are using?

Does the problem still occur if static IP addresses are used?
Comment 4 David Knierim 2005-03-14 08:46:01 EST
Created attachment 111977 [details]
Script to reproduce failure.

This script is hard coded to test the available interfaces on my box.	I do
not test eth6, since it's how I access the box :^).
Comment 5 John W. Linville 2005-03-14 11:10:08 EST

Thanks for the script...at least now I know you aren't doing anything
crazy... :-)

Any word on whether or not it happens when using only static IP addresses?
Comment 6 David Knierim 2005-03-15 13:38:55 EST
I have retested using static IP addresses.   The same problem occurs.
 It took 3 hours, 51 minutes to occur.
Comment 7 John W. Linville 2005-03-18 13:33:08 EST

I have posted some test kernels here:


These include patches to update the e1000 driver to what is currently upstream,
as well as a few other e1000 fixes.  I'd like to start with this as a baseline.

Would you mind testing these kernels to see if you can recreate the issue? 
Please post the results.  Thanks!
Comment 8 David Knierim 2005-03-21 08:35:46 EST
I tested kernel 2.4.21-31.EL.jwltest.9.1smp it ran for 8 hours, 55 minutes
before failing.  It sucessfully ran 416 up/down loops before failing.  FYI, my
box is now configured with 15 e1000 interfaces that are being brought up and
down.   I don't know if this matters, but the box is based on the Intel 7520
chipset with two 3.20GHz hyperthreaded Xeon processors. The box has 2GB of DRAM.
Comment 9 John W. Linville 2005-05-03 16:57:40 EDT
Well, after all this time I wish I had something more concrete to offer, 
I do have test kernels w/ yet another updated e1000 driver available at the 
same URL referenced in comment 7.  I'd appreciate it if you could give those a 
try in the hopes that Intel already fixed this issue for us... :-)  Please 
post the results here.  Thanks! 
Comment 10 David Knierim 2005-05-17 12:56:40 EDT
I retried this test with the latest kernel from your test area
(2.4.21-32.3.EL.jwltest.24smp) with the code commented out as requested in
comment #26 of bug 151054.  The test has been running for just under 1day, 4
hours without error.   
Comment 11 John W. Linville 2005-06-07 15:23:08 EDT
Marking this as duplicate of bug 151054 as they appear to have the same root 
cause...solution remains elusive... 

*** This bug has been marked as a duplicate of 151054 ***
Comment 12 Ernie Petrides 2005-07-11 21:08:41 EDT
A fix for this problem has just been committed to the RHEL3 U6
patch pool this evening (in kernel version 2.4.21-32.10.EL).
Comment 14 Ernie Petrides 2005-07-21 20:05:13 EDT

*** This bug has been marked as a duplicate of 151054 ***
Comment 15 Red Hat Bugzilla 2005-09-28 10:50:20 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.